﻿using System;
using System.Windows;
using Infragistics.Controls.Charts;
using Infragistics.Windows;

namespace XamDataChartDemo
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		private bool _b;
        AxisLabelSettings yaxis1Labelsettings;
        bool flag = true;
        public MainWindow()
		{
			InitializeComponent();
            this.theChart1.Axes[0].SizeChanged += MainWindow_SizeChanged;
            yaxis1Labelsettings = new AxisLabelSettings();
            yAxis1.LabelSettings = yaxis1Labelsettings;
        }
        
        private void MainWindow_SizeChanged(object sender, SizeChangedEventArgs e)
        {
            
        }

        private void test_Click(object sender, RoutedEventArgs e)
		{
			_b = !_b;
			yAxis2.Label = _b ? "{}Blaaaaaaaaaaaaaaa{0}" : null;

            if (yaxis1Labelsettings.Extent >= 119)
            {
                yaxis1Labelsettings.Extent = 50;
                yaxis1Labelsettings.Extent = 50;
            }
            else
            {
                yaxis1Labelsettings.Extent = 119;
                yaxis1Labelsettings.Extent = 119;
            }
        }

		private void UpdateExtend(object sender, EventArgs e)
		{
			VerticalAxisLabelPanel panel1 = Utilities.GetDescendantFromType(theChart1, typeof(VerticalAxisLabelPanel), false) as VerticalAxisLabelPanel;
			VerticalAxisLabelPanel panel2 = Utilities.GetDescendantFromType(theChart2, typeof(VerticalAxisLabelPanel), false) as VerticalAxisLabelPanel;

			if (panel1 == null || panel2 == null)
			{
				return;
			}

			double width1 = panel1.Width;
			double width2 = panel2.Width;

			if (double.IsNaN(width1) || double.IsNaN(width2))
			{
				return;
			}

			if (width1 == width2)
			{
				return;
			}

			//Determine which one is panel is wider, then set the Extent based on the smallest of the two.
			if (width1 < width2)
			{
				if (yAxis1.LabelSettings.Extent != width2)
				{
					yAxis1.LabelSettings.Extent = width2;
				}
                
                // How to Reset the Labelsettings to autofit?
                yAxis2.LabelSettings.Extent = 50;
            }
			else
			{
				if (yAxis2.LabelSettings.Extent != width1)
				{
					yAxis2.LabelSettings.Extent = width1;
				}

				//yAxis1.LabelSettings.Extent = 50;
			}

            //Dispatcher.BeginInvoke(new Action(() =>
            //{

            //}));
            
            //if (flag == false)
            //{
            //    if (yAxis1.LabelSettings.Extent >= 119)
            //    {
            //        yAxis1.LabelSettings.Extent = 50;
            //        yAxis2.LabelSettings.Extent = 50;
            //    }
            //    else
            //    {
            //        yAxis1.LabelSettings.Extent = 119;
            //        yAxis2.LabelSettings.Extent = 119;
            //        flag = true;
            //    }
               
            //}

                flag = false;

            ActualExtend.Text = yAxis1.LabelSettings.Extent + "/" + yAxis2.LabelSettings.Extent;
		}
	}
}
